| OpenCV 4.3.0 Open Source Computer Vision

Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::cuda::NvidiaOpticalFlow_1_0 Class Referenceabstract
CUDA-accelerated Computer Vision » Optical Flow

Class for computing the optical flow vectors between two images using NVIDIA Optical Flow hardware and Optical Flow SDK 1.0. More...

`#include <opencv2/cudaoptflow.hpp>`

Inheritance diagram for cv::cuda::NvidiaOpticalFlow_1_0:

## Public Types
enum | NVIDIA_OF_PERF_LEVEL { NV_OF_PERF_LEVEL_UNDEFINED, NV_OF_PERF_LEVEL_SLOW = 5, NV_OF_PERF_LEVEL_MEDIUM = 10, NV_OF_PERF_LEVEL_FAST = 20, NV_OF_PERF_LEVEL_MAX }

## Public Member Functions
virtual void | upSampler (InputArray flow, int width, int height, int gridSize, InputOutputArray upsampledFlow)=0
| The NVIDIA optical flow hardware generates flow vectors at granularity gridSize, which can be queried via function getGridSize(). Upsampler() helper function converts the hardware-generated flow vectors to dense representation (1 flow vector for each pixel) using nearest neighbour upsampling method. More...
Public Member Functions inherited from cv::cuda::NvidiaHWOpticalFlow
virtual void | calc (InputArray inputImage, InputArray referenceImage, InputOutputArray flow, Stream &stream=Stream::Null(), InputArray hint=cv::noArray(), OutputArray cost=cv::noArray())=0
| Calculates Optical Flow using NVIDIA Optical Flow SDK. More...
virtual void | collectGarbage ()=0
| Releases all buffers, contexts and device pointers. More...
virtual int | getGridSize () const =0
| Returns grid size of output buffer as per the hardware's capability. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< NvidiaOpticalFlow_1_0 > | create (int width, int height, cv::cuda::NvidiaOpticalFlow_1_0::NVIDIA_OF_PERF_LEVEL perfPreset=cv::cuda::NvidiaOpticalFlow_1_0::NVIDIA_OF_PERF_LEVEL::NV_OF_PERF_LEVEL_SLOW, bool enableTemporalHints=false, bool enableExternalHints=false, bool enableCostBuffer=false, int gpuId=0)
| Instantiate NVIDIA Optical Flow. More...
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class for computing the optical flow vectors between two images using NVIDIA Optical Flow hardware and Optical Flow SDK 1.0.

Note
  - A sample application demonstrating the use of NVIDIA Optical Flow can be found at opencv_source_code/samples/gpu/nvidia_optical_flow.cpp
  - An example application comparing accuracy and performance of NVIDIA Optical Flow with other optical flow algorithms in OpenCV can be found at opencv_source_code/samples/gpu/optical_flow.cpp

## Member Enumeration Documentation

## ◆ NVIDIA_OF_PERF_LEVEL

enum cv::cuda::NvidiaOpticalFlow_1_0::NVIDIA_OF_PERF_LEVEL

Supported optical flow performance levels.

Enumerator
NV_OF_PERF_LEVEL_UNDEFINED |
NV_OF_PERF_LEVEL_SLOW | Slow perf level results in lowest performance and best quality
NV_OF_PERF_LEVEL_MEDIUM | Medium perf level results in low performance and medium quality
NV_OF_PERF_LEVEL_FAST | Fast perf level results in high performance and low quality
NV_OF_PERF_LEVEL_MAX |

## Member Function Documentation

## ◆ create()

static Ptr<NvidiaOpticalFlow_1_0> cv::cuda::NvidiaOpticalFlow_1_0::create | ( | int | width,
|  | int | height,
|  | cv::cuda::NvidiaOpticalFlow_1_0::NVIDIA_OF_PERF_LEVEL | perfPreset = `cv::cuda::NvidiaOpticalFlow_1_0::NVIDIA_OF_PERF_LEVEL::NV_OF_PERF_LEVEL_SLOW`,
|  | bool | enableTemporalHints = `false`,
|  | bool | enableExternalHints = `false`,
|  | bool | enableCostBuffer = `false`,
|  | int | gpuId = `0`
| ) |  |
| static

Instantiate NVIDIA Optical Flow.

Parameters

  width | Width of input image in pixels.
  height | Height of input image in pixels.
  perfPreset | Optional parameter. Refer NV OF SDK documentation for details about presets. Defaults to NV_OF_PERF_LEVEL_SLOW.
  enableTemporalHints | Optional parameter. Flag to enable temporal hints. When set to true, the hardware uses the flow vectors generated in previous call to calc() as internal hints for the current call to calc(). Useful when computing flow vectors between successive video frames. Defaults to false.
  enableExternalHints | Optional Parameter. Flag to enable passing external hints buffer to calc(). Defaults to false.
  enableCostBuffer | Optional Parameter. Flag to enable cost buffer output from calc(). Defaults to false.
  gpuId | Optional parameter to select the GPU ID on which the optical flow should be computed. Useful in multi-GPU systems. Defaults to 0.

## ◆ upSampler()

virtual void cv::cuda::NvidiaOpticalFlow_1_0::upSampler | ( | InputArray | flow,
|  | int | width,
|  | int | height,
|  | int | gridSize,
|  | InputOutputArray | upsampledFlow
| ) |  |
| pure virtual

The NVIDIA optical flow hardware generates flow vectors at granularity gridSize, which can be queried via function getGridSize(). Upsampler() helper function converts the hardware-generated flow vectors to dense representation (1 flow vector for each pixel) using nearest neighbour upsampling method.

Parameters

  flow | Buffer of type CV_16FC2 containing flow vectors generated by calc().
  width | Width of the input image in pixels for which these flow vectors were generated.
  height | Height of the input image in pixels for which these flow vectors were generated.
  gridSize | Granularity of the optical flow vectors returned by calc() function. Can be queried using getGridSize().
  upsampledFlow | Buffer of type CV_32FC2, containing upsampled flow vectors, each flow vector for 1 pixel, in the pitch-linear layout.

The documentation for this class was generated from the following file:

- opencv2/cudaoptflow.hpp